---
title: Filter query fields
slug: model-api/filter-query-fields
docTags: 
createdAt: 2026-04-14T12:07:21.044Z
---

{
  "id": "45BOZZaFLNBR8NSKAqvE2",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields",
    "servers": [
      {
        "url": "https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields"
      }
    ],
    "name": "Filter query fields",
    "description": "List all the queryable product fields in a project. Accepts an optional request body to filter by multiple models or revisions.",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "project-id",
          "type": "string",
          "example": "af2d8af0fa54465b89bf26dd3d92cfd0",
          "description": "Catenda project id"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "data-mode",
          "type": "string",
          "description": "<p>Data mode for IFC data. <code>explicit</code> returns data as stored. <code>inferred</code> merges type properties with product properties.</p>",
          "default": "explicit",
          "enum": [
            "explicit",
            "inferred"
          ]
        },
        {
          "kind": "optional",
          "name": "model",
          "type": "array",
          "description": "Filter by latest revision of model id.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "revision",
          "type": "array",
          "description": "Filter by revision id. Can be repeated to filter by multiple revisions.",
          "schema": [],
          "itemType": "string",
          "customType": "string[]"
        },
        {
          "kind": "optional",
          "name": "page",
          "type": "integer",
          "description": "Default value is 1"
        },
        {
          "kind": "optional",
          "name": "pageSize",
          "type": "integer",
          "description": "<p>Default 100, max 1000</p>"
        }
      ],
      "bodyDataParameters": [
        {
          "kind": "optional",
          "name": "body",
          "type": "object",
          "description": "",
          "schema": [
            {
              "name": "models",
              "kind": "optional",
              "type": "array",
              "description": "Filter by latest revision of model ids",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "revisions",
              "kind": "optional",
              "type": "array",
              "description": "Filter by revision ids",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            }
          ],
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "Bearer",
          "name": "Bearer",
          "kind": "optional",
          "type": "http",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "array",
            "description": "",
            "customType": "ifc-field[]",
            "schema": [
              {
                "name": "field",
                "kind": "optional",
                "type": "string",
                "description": "The name of the field",
                "example": "objectId"
              },
              {
                "name": "type",
                "kind": "optional",
                "type": "string",
                "description": "The type of the field",
                "example": "string"
              },
              {
                "name": "measureType",
                "kind": "optional",
                "type": "string",
                "nullable": true,
                "description": "The measure type of the field",
                "example": "length"
              }
            ],
            "modelRef": "#/components/schemas/ifc-field",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "wAfFOfMP00cOBSeznvkfS",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url 'https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields?data-mode=explicit' \\\n     --header 'accept: application/json'"
        },
        {
          "id": "Um2Hb_8VWx8_r7Sesuc1M",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields?data-mode=explicit\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "sZfs_lnrefqcSn4TIZVfa",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields?data-mode=explicit\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "EX6q9tfeRRT0x4auGMrWG",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.catenda.com/v2/projects/{project-id}/ifc/products/fields?data-mode=explicit\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "wAfFOfMP00cOBSeznvkfS"
    },
    "results": {
      "languages": [
        {
          "id": "DJrrAXDrxLimS8pT1Csh9",
          "language": "200",
          "code": "// OK\n[\n  {\n    \"field\": \"objectId\",\n    \"type\": \"string\",\n    \"measureType\": \"length\"\n  }\n]"
        }
      ],
      "selectedLanguageId": "DJrrAXDrxLimS8pT1Csh9"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}